package PateLib;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import sun.awt.image.FileImageSource; 

// *****************************************************
// ************METHOD INDEX*****************************
// *****************************************************
// CONSTRUCTORS:
// public AboutDialog(Frame parent,String f)
// METHODS:
// private void FindPlaceForButton(Button ok, Dimension d)
// public void actionPerformed(ActionEvent evt)

public class AboutDialog extends Dialog implements ActionListener
{
	private Button myOkButton;
	String filename;

	public AboutDialog(Frame parent, String f, String mesg, int h, int w)
	// constructor
	// parent: parent frame
	// f: name of image file to load
	{
		super(parent,"About "+Params.Name, true);
		filename = f;

		PicturePanel PicPanel = new PicturePanel(filename, mesg, h, w);
		PicPanel.setLayout(null);
		Dimension d = PicPanel.getSize();
		
		myOkButton = new Button("OK");
		myOkButton.addActionListener(this);
		FindPlaceForButton(myOkButton, d);

		setSize(d.width,d.height);

		PicPanel.add(myOkButton);
		add("Center",PicPanel);

		this.addWindowListener(
		     new WindowAdapter()
		     {
			public void windowClosing(WindowEvent e)
			{
			   AboutDialog.this.dispose();
			}
		     }
		);
	}		

	private void FindPlaceForButton(Button ok, Dimension d)
	// postcondition: button is located on the 
	// bottom of the picture
	{
		int x = d.width/2 - 30;
		int y = d.height - 60;
		if (x<0)
			x=0;
		if (y<0)
			y=0;
		myOkButton.setBounds(x,y,50,20);
	}

	public void actionPerformed(ActionEvent evt)
	// action handling
	{
		if (evt.getSource() == myOkButton)
		{
			dispose();
			//return true;
		}
		//return false;
	}
}




// CONSTRUCTORS:
// PicturePanel(String f)
// METHODS:
// public void paint (Graphics g)
// public void DrawText(Graphics g)

class PicturePanel extends Panel
// a panel which displays an image
{
	Image img;
	private String message;
	private int width, height;

	PicturePanel(String f, String mesg, int h, int w)
	// constructor
	// f: name of image file to load
	{
		super();
		String filename = f;
		message = mesg;
		img = this.getToolkit().getImage(filename);

		width = w;
		height = h;	
		setSize(width,height);
		repaint ();
	}


	public void paint (Graphics g)
	// postcondition: image is painted on the panel
	{
		g.drawImage(img, 0, 0, this);
		DrawText(g);	
	}

	public void DrawText(Graphics g)
	// postcondition: text is drawn on the panel
	{
		String s;
		int x,y, dy;
		
		g.setFont(Params._ad_font);
		g.setColor(Params._ad_textcolor);

		FontMetrics fm = g.getFontMetrics();
		dy = fm.getHeight();
		x = 30;
		y = dy + 10;
		/*g.drawString("Brute Parser V1.0",width/2-80,30);
		g.setFont(Params._ad_font);
		g.drawString("August 1996",width/2-80, 60);
		g.drawString("(c) Susan H. Rodger",width/2-80,80);
		g.drawString("Anna O. Bilska (Anya)",width/2-80,100);*/

		StringTokenizer st = new StringTokenizer(message,"\n");

		while(st.hasMoreTokens())
		{	
			s = st.nextToken();
			x = width/2 - fm.stringWidth(s)/2;
			if (x<0)
				x = 0;
			g.drawString(s,x,y);
			y += dy;
		}
	}
}





















































