package PateLib;

import java.awt.*;
import java.awt.event.*;

//
//
// AddRuleDialog
//
//
public class AddRuleDialog extends Dialog implements ActionListener
{
    private Button myAdd;
    private Button myCancel;
    private TextField myLeftText;
    private TextField myRightText;
    private String result;
    private Frame myParent;

    public AddRuleDialog(Frame parent)
    {
	super(parent, "Add a Rule", true);

	myParent = parent;
	result = "";

        setFont(Params._dg_font);
	setBackground(Params._dg_backcolor);
	setLayout(new BorderLayout());
        Panel p = new Panel();
	p.add(myAdd = new Button("Add Rule"));
	myAdd.addActionListener(this);
	p.add(myCancel = new Button("Cancel"));
	myCancel.addActionListener(this);
	add(p, "South");

	p = new Panel(new FlowLayout());
	p.add(myLeftText = new TextField(10));
	myLeftText.addActionListener(this); 
	p.add(new Label("->", Label.CENTER));
	p.add(myRightText = new TextField(20));
	add(p, "Center");

	add(new Label("Input the rule to add to the grammar: "), "North");
	pack();
    }

    /**
     * Returns the string of the rule to be added
     */
    public String getResult()
    {
	return result;
    }

    public void actionPerformed(ActionEvent e)
    {
	if(e.getSource() == myAdd)
	{
	    if(!myLeftText.getText().equals(""))
	    {
		result = myLeftText.getText() + "->" + 
		    myRightText.getText();
	    }
	    else
	    {
		OKDialog dg = new OKDialog("Left hand side cannot be\n a lambda.",
		    myParent, "Error");
		dg.showResize();
		return;
	    }
	}
	else if(e.getSource() == myCancel)
	{
	    result = "";
	}
	setVisible(false);
    }	    // end of method action.

}

