package PateLib;

import java.awt.*;
/*
---------------------------------------------------------------------------
File	    :		DividerCanvas.java
Package	    :		PateLib  Version 1.1
Author	    :		Ted Hung
Programmed  :		Aug 1999	
Modified    :
---------------------------------------------------------------------------
 *
 * 
 * Susan H. Rodger, Anna O. Bilska (Anya), Jason R. Salemme, Ted Hung
 * Computer Science Department
 * Duke University
 * August 1999
 * Supported by National Science Foundation DUE-9596002, DUE-9555084,
 *  and DUE-9752583.
 *
 * Copyright (c) 1999
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the author.  The name of the author may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */
public class DividerCanvas extends Canvas
{
    String drawStr;

    public DividerCanvas(String str)
    {
	super();
	drawStr = str;
	setSize(20, 100);
	setVisible(true);
    }

    public void calcSize()
    {
	Font font = getGraphics().getFont();
	getGraphics().setFont(
	    new Font("SansSerif", Font.BOLD, font.getSize()));
	FontMetrics fm = getGraphics().getFontMetrics();

	int width = fm.stringWidth(drawStr) + 30;
	int height = fm.getHeight();
	setSize(width, height);
    }

    public void paint(Graphics g)
    {
	Dimension d = getSize();
	FontMetrics fm = g.getFontMetrics();

	g.setColor(Color.black);
	g.fillRect(0, 0, d.width, d.height);

	g.setColor(getBackground());
	g.drawString(drawStr, 15, 0); 
    }
}

