/*---------------------------------------------------------------------------
File:         			Pate.java
Package:                        PateLib  Version 1.0
Author:				Anna O. Bilska (Anya) V1.0 08/07/96
                                
Description of Contents:       
				
--------------------------------------------------------------------------*/

/* 
 * Susan H. Rodger, Anna O. Bilska (Anya), Jason R. Salemme
 * Computer Science Department
 * Duke University
 * August 1996
 * Supported by National Science Foundation DUE-9596002 and DUE-9555084.
 *
 * Copyright (c) 1996
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the author.  The name of the author may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

package PateLib;

import java.lang.*;
import java.util.*;

// GrammarString class: manipulates
// strings

// *****************************************************
// ************METHOD INDEX*****************************
// *****************************************************
// CONSTRUCTORS:
// public GString(String bigS)
// METHODS:
// public boolean Contains(String subS, Vector positions)

public class GString 
{

	public GString(String bigS)
	// constructor
	{
		myBigS = bigS;
	}
	
	public boolean Contains(String subS, Vector positions)
	// postcondition: returns true if the GString contains
	// subS, and if so, places the positions of the 
	// occurances in the 'positions' vector
	{
		mySubS = subS;
		myLen = mySubS.length();
		myLastIndex = myBigS.length() - myLen;
		int k=0;
		positions.removeAllElements();
		while( k <= myLastIndex)
		{
			if (myBigS.regionMatches(k,mySubS,0,myLen))
			{
				positions.addElement(new Integer(k));
			}	
			k++;
		}
		if (!positions.isEmpty())
			return true;
		return false;
	
	}

	
	public String Exchange(int replaceIndex, String replacedText,
				String replaceeText)
	// postconditon: 'replacedText' is replaced with 'replaceeText' 
	// at position 'replaceIndex'
	{
		String part1;
		String part2;
		String part3;
		int temp = replaceIndex + replacedText.length();
	
		if (replaceIndex>myBigS.length())
			replaceIndex=0;
		if (temp>myBigS.length())
			temp=myBigS.length();
		part1 = myBigS.substring(0, replaceIndex);
		part2 = replaceeText;
		part3 = myBigS.substring(temp, myBigS.length());
		return (part1+part2+part3);
	}

	

	private String myBigS;
	private String mySubS; // the substring
	private int myLen;     // length of the substring
	private int myLastIndex; 

}











