/*---------------------------------------------------------------------------
File:         			HelpWindow.java
Package:                        PateLib
Author:				Ted Hung
 
Description of Contents:	Contains abstract base class HelpWindow
				
--------------------------------------------------------------------------*/

/* 
 * Susan H. Rodger, Magda Procopiuc, Octavian Procopiuc, Eric Gramond, Ted Hung
 * Computer Science Department
 * Duke University
 * August 1999
 * Supported by National Science Foundation DUE-9596002, DUE-9555084,
 *  and DUE-9752583
 *
 * Copyright (c) 1999
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the author.  The name of the author may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

package PateLib;

//
//
// HelpWindow
//
//

import java.awt.*;

abstract public class HelpWindow extends Frame 
{
    /**
     * sets the current topic with a simple string. This should make it easy
     * to call this from the outside.
     */
    abstract public void setCurrentTopic(String topicName);

    /**
     * returns a string that identifies what type of help window it is
     */
    abstract public String getType();
}

