package PateLib;

import java.awt.*;

/*
---------------------------------------------------------------------------
File	    :		Message.java
Package	    :		PateLib  Version 1.0
Author	    :		Jason Robert Salemme
Programmed  :		8 Aug 96	
Modified    :
---------------------------------------------------------------------------
 *
 * 
 * Susan H. Rodger, Anna O. Bilska (Anya), Jason R. Salemme
 * Computer Science Department
 * Duke University
 * August 1996
 * Supported by National Science Foundation DUE-9596002 and DUE-9555084.
 *
 * Copyright (c) 1996
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the author.  The name of the author may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/**
 * This class opens a TextInDialog box with a specified size.  Handy for those
 * loooooooong messages.
 */
public class Message extends TextInDialog
{
    final static private String	    OK_STRING = " OK ";
    final static private String[]   OKButtonStr = {OK_STRING};

/**
 * Allocates a new instance of the class Message.
 * @param message the message to display
 * @param parent the parent frame
 * @param title the title for the dialog box.
 * @param h the height of the dialog box (in pixles)
 * @param w the width of the dialog box (in pixles)
 */
    public Message(String message, Frame parent, String title, int h, int w){
	super(message, OKButtonStr, parent, title, h, w);
    }
}
