package PateLib;

import java.util.*;
import java.awt.*;
import java.io.*;
import java.awt.image.*;
import java.awt.event.*;

/*
---------------------------------------------------------------------------
File	    :		ModifyTextField.java
Package	    :		PateLib  Version 1.1
Author	    :		Ted Hung
Programmed  :		Aug 1999	
Modified    :
---------------------------------------------------------------------------
 *
 * 
 * Susan H. Rodger, Anna O. Bilska (Anya), Jason R. Salemme, Ted Hung
 * Computer Science Department
 * Duke University
 * August 1999
 * Supported by National Science Foundation DUE-9596002, DUE-9555084,
 *  and DUE-9752583.
 *
 * Copyright (c) 1999
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the author.  The name of the author may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/**
 * provides a text field which will set a modified flag
 * when it is changed
 */
public class ModifyTextField extends TextField
{
    public boolean modified;
    public ModifyTextField(int size)
    {
	super(size);
	modified = false;
	this.addKeyListener(new KeyAdapter()
	{
	    public void keyTyped(KeyEvent e)
	    {
		modified = true;
	    }
	});
    }

    public void setModifiedFlag()
    {
	modified = true;
    }

    public void resetModifiedFlag()
    {
	modified = false;
    }
}


