package PateLib;

import java.awt.*;

/*---------------------------------------------------------------------------
File:         			Params.java
Package:                        PateLib  Version 1.0
Author:				Anna O. Bilska (Anya), Jason R. Salemme -
				V1.0 07/15/96
Modified:
Description of Contents:       
				
--------------------------------------------------------------------------*/

/* 
 * Susan H. Rodger, Anna O. Bilska (Anya), Jason R. Salemme
 * Computer Science Department
 * Duke University
 * August 1996
 * Supported by National Science Foundation DUE-9596002 and DUE-9555084.
 *
 * Copyright (c) 1996
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the author.  The name of the author may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

//package PateLib;

public class Params {


   //global environment parameters
    public static char	    eChar = '\u00E9';
    public static char	    bigEChar = '\u00C9';
    public static char	    aChar = '\u00E2';
    public static char	    bigAChar = '\u00C2';
    public static String    Name = "P" + aChar + "t" + eChar + " - ";
    public static String    Name2 = "P" + aChar + "t" + eChar;
    public static Color	    normalColor = Color.black;
    public static Color	    textBkgrd = Color.white;
    public static Color	    textColor = Color.blue;
    public static Color	    errTextColor = Color.red;
    public static Font	    normalFont = new Font("TimesRoman", Font.PLAIN, 12);
    public static Font	    menuFont = new Font("TimesRoman", Font.PLAIN + Font.BOLD, 14);
    public static Font	    labelFont = new Font("TimesRoman", Font.PLAIN + Font.BOLD, 16);
    public static Font	    errLabelFont = new Font("TimesRoman", Font.PLAIN, 14);

    public static Font	    smallLabelFont = new Font("TimesRoman", Font.PLAIN, 12);
    public static Font	    fileFont = errLabelFont;


    public static char	    lambdaChar = '\u00D8';
    /*  Don't ask me why this number is not 216 because I have no idea!  If you
     * need to compare a character from a string, or whatever, you have to use
     * the lambdaCharValue for the comparison to work (for some reason the
     * system casts the lambdaChar to an int value of 65496.
     */
    public static int	    lambdaCharValue = 65496;
/* ***************************************************************************
 *   If the above two lines will not work on your system comment them out and
 * use the two lines below.  You can change the lambdaChar to any letter you
 * want but you will not be able to use it as a variable or terminal any more.
 * You can not use the character 'S' however...
 *    public static char    lambdaChar = 'l';
 *    public static int	    lambdaCharValue = (int)lambdaChar;
 *****************************************************************************/

    //Lambda production removal frame parameters
    public static String    lambdaName = "Lambda Removal - ";
    public static int	    lambdaWidth = 275;
    public static int	    lambdaHeight = 600;

    //Unit production removal frame parameters
    public static String    unitName = "Unit Removal - ";
    public static int	    unitWidth = 275;
    public static int	    unitHeight = 540;

    //Useless production removal frame parameters
    public static String    uselessName = "Useless Removal - ";
    public static int	    uselessWidth = 275;
    public static int	    uselessHeight = 540;


    //CNF frame parameters
    public static String    CNFName = "CNF - ";
    public static int	    CNFWidth = 275;
    public static int	    CNFHeight = 460;

 
    // ScrollCanvas parameters:
    public static Color _scroll_bkcolor = Color.white;
    public static Color _scroll_barcolor = Color.lightGray;
    public static Font  _scroll_drvfont = new Font("TimesRoman",Font.PLAIN,14);
    public static Color _scroll_drvcolor = Color.black;
    public static Color _scroll_prodcolor = Color.blue;
    public static Color _scroll_highcolor = Color.red;
    public static Color _scroll_nodecolor = Color.white;
    public static Color _scroll_leafnodecolor = Color.yellow;
    public static Color _scroll_edgescolor = Color.black;
    public static Color _scroll_groupcolor = new Color(128, 128, 255);

    // AboutDialog parameters:
    public static Font _ad_titlefont = new Font("TimesRoman", Font.PLAIN, 18); 
    public static Font _ad_font = new Font("TimesRoman", Font.ITALIC, 17);
    public static Color _ad_textcolor = Color.white;
    public static int _ad_width = 260;
    public static int _ad_height = 190;
    public static String    trans1Pic = "./Images/about1.gif";
    public static String    trans2Pic = "./Images/about2.gif";
    public static String    parserPic = "./Images/about3.gif";
    public static int	    aboutHeight = 230;
    public static int	    aboutWidth = 225;

    // SmilyIndicator parameters:
    public static Color _smily_bkcolor = Color.lightGray;

    // HelpDialog parameters:
    public static Font  _hd_font = new Font("TimesRoman", Font.PLAIN, 12);
    public static Color _hd_bkcolor = Color.lightGray;
    public static Color _hd_color = Color.black;
    public static int	_hd_height = 500;
    public static int	_hd_width = 460; 
    // dialogs parameters:
    public static Font	_dg_font = new Font("TimesRoman", Font.PLAIN, 14);
    public static Color	_dg_backcolor = new Color(229, 229, 229);
    public static Color	_dg_forecolor = Color.black;
    public static int	_dg_width = 270;
    public static int	_dg_height = 170;

    // ProdEnvironment parameters:
    public static Font	_pe_font = new Font("TimesRoman", Font.PLAIN, 14);
    public static Color	_pe_backcolor = new Color(229, 229, 229);
    public static Color	_peforecolor = Color.black;
    public static int	_pe_width = 270;
    public static int	_pe_height = 170;

    public static char LAMBDA = 'l';
}

