/*---------------------------------------------------------------------------
File:         			Pate.java
Package:				PateLib  Version 1.0
Author:					Anna O. Bilska (Anya) V1.0 08/07/96
                                

--------------------------------------------------------------------------*/

/* 
 * Susan H. Rodger, Anna O. Bilska (Anya), Jason R. Salemme
 * Computer Science Department
 * Duke University
 * August 1996
 * Supported by National Science Foundation DUE-9596002 and DUE-9555084.
 *
 * Copyright (c) 1996
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the author.  The name of the author may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

package PateLib;

import java.lang.*;
import java.util.*;


// Anya Biska
// summer 1996
// D.R.O.O.L. project

// a position tree class - a fast
// way of checking whether something
// has already been used 
// (in this case, strings)


// ***************************************************
// ***METHOD INDEX************************************
// ***************************************************
// CONSTRUCTOR:
// public void PositionTree()
// METHODS:
// public boolean ContainsAlsoAdd(String lookedfor)
// private void AddWord(String lookedfor)


public class PositionTree
{
	private String myLookedFor;
	private boolean wentToSide;
	private int myCount;
	private int myLen;
	private PosLink myAt;
	private PosLink myHead;
	private PosLink myPrev;

	public PositionTree()
	// constructor
	{
		myHead = null;
		myAt = null;
		myPrev = null;
	}


	public boolean ContainsAlsoAdd(String lookedfor)
	// postcondition: if the word is alreay in the structure
	// returns true;  otherwise returns false and adds the 
	// word to the structure
	// (ContainsAlsoAdd is written as one function to 
	//  make it fast)
	{
		myCount = 0;
		myLookedFor = lookedfor;
		myLen = lookedfor.length();
		myAt = myHead;
		myPrev = myAt;
		wentToSide = false;

		while (myCount<myLen)
		{
			
			while ((myAt!=null) && (myAt.letter != lookedfor.charAt(myCount)))
			{
				myPrev = myAt;
				myAt = myAt.sibling;
				wentToSide = true;	
			}
			
			if ((myAt == null))
			{
				AddWord(myLookedFor);
				return false;
			}
			myPrev = myAt;
			myAt = myAt.child;
			wentToSide = false;
			myCount++;
		}
		if (myAt == null)
			return true;
		return false;
	}

	private void AddWord(String lookedfor)
	// precondition: the word is not in the sturcture
	// postcondition: the word is added to the structure
	{
		if (myPrev==null)
		{
			myHead = new PosLink(lookedfor.charAt(myCount),null,null);
			myAt = myHead;
			myPrev = myAt;
			myCount++;
		}
		myAt = myPrev;
		if ((wentToSide) && (myCount<myLen))
		{
			myAt.sibling = new PosLink(lookedfor.charAt(myCount),
								null,null);
			myAt = myAt.sibling;
			myCount++;	
		}
		while (myCount<myLen)
		{
			myAt.child = new PosLink(lookedfor.charAt(myCount),
								null,null);
			myAt = myAt.child;
			myCount++;
		}
				
	}

}


class PosLink
// a node in the position tree
{
	char letter;
	PosLink child;
	PosLink sibling;
  
	PosLink(char let, PosLink c, PosLink s)
	{
		letter = let;
		child = c;
		sibling = s;
	} 
}	