/*---------------------------------------------------------------------------
File:         			Pate.java
Package:                        PateLib  Version 1.0
Author:				Anna O. Bilska (Anya) V1.0 08/07/96
                                
Description of Contents:       
				
--------------------------------------------------------------------------*/

/* 
 * Susan H. Rodger, Anna O. Bilska (Anya), Jason R. Salemme
 * Computer Science Department
 * Duke University
 * August 1996
 * Supported by National Science Foundation DUE-9596002 and DUE-9555084.
 *
 * Copyright (c) 1996
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the author.  The name of the author may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

package PateLib;

import java.util.*;

// a class which simulates a queue
// of objects


// ***************************************************
// ***METHOD INDEX************************************
// ***************************************************
// CONSTRUCTOR:
// public Queue()
// METHODS:
// public void Enqueue(Object): puts an element in the queue
// public Object Dequeue(): takes and element off the queue and returns it
// public Object GetFront(): returns the first element (does NOT take it
// off)
// public boolean Size(): returns the num of objects in the queue
// public boolean IsEmpty(): returns true if the list is empty
// public void MakeEmpty(): deletes everything from the queue


public class Queue
{
	public Queue()
	// constructor
	{
		myHead = null;
		myTail = null;
		numObjs = 0;
	}

	public void Enqueue(Object ob)
	// postcondition: ob is added to the queue
	{
		Link p = new Link(ob, null);
		if (myHead == null)
		{
			myHead = p;
			myTail = p;
		}
		else
		{
			myTail.next = p;
			myTail = p;
		}
		numObjs++;
	}

	public Object Dequeue()
	// postcondition: the first element in the list
	// is taken out of the queue and returned
	{
		Object info;
		if (myHead == null)
			throw new java.util.NoSuchElementException();
		else 
		{
			info = myHead.data;
			myHead = myHead.next;
			numObjs--;
		}
		if (myHead == null)
			myTail = null;
		return info;

	}

	public Object GetFront()
	// postcondition: returns the first element in 
	// queue (does NOT take it off)
	{
		if (myHead == null)
			throw new java.util.NoSuchElementException();
		else
			return myHead.data;
	}
	
	public boolean IsEmpty()
	// postcondition: returns true if there is 
	// nothing in the queue
	{
		if (myHead == null)
			return true;
		return false;
	}
	
	public void MakeEmpty()
	// postcondition: removes everything from the queue
	{
		myHead = myTail = null;
		numObjs = 0;
	}

	public int Size()
	// postcondition: returns how many objects are stored
	// in the queue
	{
		return numObjs;
	}
	
	private Link myHead;
	private Link myTail;
	private int numObjs;
}

class Link
{
	Object data;
	Link next;
	Link(Object o, Link n)
	{
		data = o;
		next = n;
	}
}
