/*---------------------------------------------------------------------------
File:         			Pate.java
Package:                        PateLib  Version 1.0
Author:				Anna O. Bilska (Anya) V1.0 08/07/96
                                
Description of Contents:       
				
--------------------------------------------------------------------------*/

/* 
 * Susan H. Rodger, Anna O. Bilska (Anya), Jason R. Salemme
 * Computer Science Department
 * Duke University
 * August 1996
 * Supported by National Science Foundation DUE-9596002 and DUE-9555084.
 *
 * Copyright (c) 1996
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the author.  The name of the author may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

package PateLib;

import java.lang.*;
import java.util.*;

// Anya Bilska
// summer 1996

// a shifter which allows
// an economical way to store
// two small numbers in one field (int)
// stores such that: 0-15: index; 16-31: production



// ***************************************************
// ***METHOD INDEX************************************
// ***************************************************
// CONSTRUCTORS:
// public Shifter() 
// METHODS:
// public int TwoIntoOne(int i, int p)
// public int GetIndex(int num)
// public int GetProd(int num)
// public int GetFirst(int num)
// public int GetSecond(int num)

public class Shifter
{
	public Shifter()
	// constructor
	{
		ans = 0;
	}

	public int TwoIntoOne(int i, int p)
	// postcondition: i and p are
	// stored in one int field  -> 'ans'
	// which the method returns
	{
		ans = p<<16;
		ans += i;
		return ans;
	}

	public int GetIndex(int num)
	// postcondition: returns the 
	// first number stored
	// this method is needed for the 
	// parser only, since it is same as GetFirst
	{
		return (num & 65535); 
	}

	public int GetProd(int num)
	// postcondition: returns the 
	// second number stored
	// this method is needed for the 
	// parser only, since it is same as GetSecond
	{
		return (num >> 16);
	}


	public int GetFirst(int num)
	// postcondition: returns the 
	// first number stored
	{
		return (num & 65535); 
	}

	public int GetSecond(int num)
	// postcondition: returns the 
	// second number stored
	{
		return (num >> 16);
	}


	private int ans;
}
